<?php
/*******************************************************************************

    Author ......... Jimmy Conner
    Contact ........ jimmy@sqmail.org
    Home Site ...... http://cactiusers.org
    Program ........ Syslog Plugin for Cacti
    Purpose ........ Sylog like logging for cacti
    Originally released as aloe by: sidewinder <sidewinder@shitworks.com> 
    Modified by: Harlequin harlequin@cyberonic.com>
    
*******************************************************************************/

function plugin_init_haloe() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['haloe'] = 'haloe_show_tab';
	$plugin_hooks['top_graph_header_tabs']['haloe'] = 'haloe_show_tab';
	$plugin_hooks['config_arrays']['haloe'] = 'haloe_config_arrays';
	$plugin_hooks['draw_navigation_text']['haloe'] = 'haloe_draw_navigation_text';
	$plugin_hooks['config_form']['haloe'] = 'haloe_config_form';
	$plugin_hooks['top_graph_refresh']['haloe'] = 'haloe_top_graph_refresh';
	$plugin_hooks['config_settings']['haloe'] = 'haloe_config_settings';
	$plugin_hooks['poller_bottom']['haloe'] = 'haloe_poller_bottom';
}

function haloe_version () {
	return array( 'name' 	=> 'haloe',
			'version' 	=> '0.2',
			'longname'	=> 'Syslog Monitoring',
			'author'	=> 'Jimmy Conner',
			'homepage'	=> 'http://cactiusers.org',
			'email'	=> 'jimmy@sqmail.org',
			'url'		=> 'http://cactiusers.org/cacti/versions.php'
			);
}

function haloe_poller_bottom () {
	global $config, $database_hostname, $database_username, $database_password, $database_default, $database_type;
	include($config["base_path"] . '/plugins/haloe/config.php');
	include($config["base_path"] . '/plugins/haloe/functions.php');

	/* CONNECT TO OUR DATABASE */
	db_connect_real($haloedb_hostname, $haloedb_username, $haloedb_password, $haloedb_default, $haloedb_type);

	/* DELETE ALL OLD ITEMS FROM THE SYSLOG TABLE */
	db_execute("DELETE FROM " . $haloe_config["haloeTable"] . " WHERE DATE_SUB(CURDATE(),INTERVAL 30 DAY) > date");

	/* FLAG ALL THE CURRENT ITEMS TO WORK WITH */
	db_execute("UPDATE " . $haloe_config["incomingTable"] . " set status=1");

	/* REMOVE ALL THE THINGS WE DONT WANT TO SEE */
	syslog_remove_items($haloe_config["incomingTable"]);

	/* SEND OUT ALERTS ON THINGS WE SPECIFY */
	$alertarray = db_fetch_assoc("SELECT * FROM " . $haloe_config["alertTable"]);
	foreach ($alertarray as $alert) {
		$sql = '';
		$alertm = '';
		if ($alert['type'] == 'messageb') {
			$sql = 'select * from ' . $haloe_config["incomingTable"] . " where " . $haloe_config["textField"] . " like '" . $alert['msg'] . "%' and status=1";
		}
		if ($alert['type'] == 'messagec') {
			$sql = 'select * from ' . $haloe_config["incomingTable"] . " where " . $haloe_config["textField"] . " like '%" . $alert['msg'] . "%' and status=1";
		}
		if ($alert['type'] == 'messagee') {
			$sql = 'select * from ' . $haloe_config["incomingTable"] . " where " . $haloe_config["textField"] . " like '%" . $alert['msg'] . "' and status=1";
		}
		if ($alert['type'] == 'host') {
			$sql = 'select * from ' . $haloe_config["incomingTable"] . " where " . $haloe_config["hostField"] . "='" . $alert['msg'] . "' and status=1";
		}
		if ($sql != '') {
			$at = db_fetch_assoc($sql);
			foreach ($at as $a) {
				$alertm .= "<table cellpadding=1 cellspacing=0 border=0 bgcolor='#000000' width=500><tr><td><table width='100%' cellpadding=1 cellspacing=0 border=0 bgcolor='#FFFFFF'>\n";
				$alertm .= '<tr bgcolor="#dedede"><td>Hostname</td><td>: ' . $a['host'] . "</td></tr>\n";
				$alertm .= '<tr bgcolor="#dedede"><td>Date</td><td>: ' . $a['date'] . ' ' . $a['time'] . "</td></tr>\n";
				$alertm .= '<tr bgcolor="#dedede"><td>Severity</td><td>: ' . $a['priority'] . "</td></tr>\n";
				$alertm .= '<tr bgcolor="#dedede"><td>Message</td><td>: ' . $a['msg'] . "</td></tr>\n";
				$alertm .= '<tr bgcolor="#000000"><td colspan=2 height=1>' . "</td></tr>\n";
				$alertm .= '<tr><td colspan=2>' . $a['message'] . "\n</td></tr>";
				$alertm .= "</table></td></tr></table><br><br>\n";
			}
		}
		if ($alertm != '') {
			$css = '<style type="text/css">
					body {
					 scrollbar-face-color:#C0C0C0;
					 scrollbar-highlight-color:#F3F3F3;
					 scrollbar-3dlight-color:#EFEFEF;
					 scrollbar-darkshadow-color:#000000;
					 scrollbar-shadow-color:#408080;
					 scrollbar-arrow-color:#FFFFFF;
					 scrollbar-track-color:#ACACAC;
					 font-family: verdana, arial, "ms sans serif", sans-serif;
					 font-size: 10px;
					 }
					td { 
					 font-family: verdana, arial, "ms sans serif", sans-serif; 
					 font-size: 10px;
					 color: #333333;
					 }
					</style>';

			$alertm = "<html><head>$css</head><body>" . $alertm . '</body></hmtl>';
			syslog_sendemail($alert['email'],'','Event Log Alert', $alertm);
		}
	}




        /* MOVE ALL FLAGGED MESSAGES TO THE SYSLOG TABLE */
        $sql = 'INSERT INTO ' . $haloe_config["haloeTable"] . ' (' .
                                        $haloe_config["dateField"] . ', ' .
                                        $haloe_config["timeField"] . ', ' .
                                        $haloe_config["priorityField"] . ', ' .
                                        $haloe_config["facilityField"] . ', ' .
                                        $haloe_config["hostField"] . ', ' .
                                        $haloe_config["textField"] . ') ' .
                                        'SELECT ' .
                                        $haloe_config["dateField"] . ', ' .
                                        $haloe_config["timeField"] . ', ' .
                                        $haloe_config["priorityField"] . ', ' .
                                        $haloe_config["facilityField"] . ', ' .
                                        $haloe_config["hostField"] . ', ' .
                                        $haloe_config["textField"] .
                                         ' FROM ' . $haloe_config["incomingTable"] . ' where status=1';
        db_execute($sql);

/* OLD CODE
	$messages = db_fetch_assoc("SELECT * FROM " . $haloe_config["incomingTable"] . " where status=1");
	foreach ($messages as $message) {
		$sql = 'INSERT INTO ' . $haloe_config["haloeTable"] . ' (' . 
						$haloe_config["dateField"] . ', ' .
						$haloe_config["timeField"] . ', ' .
						$haloe_config["priorityField"] . ', ' .
						$haloe_config["facilityField"] . ', ' .
						$haloe_config["hostField"] . ', ' .
						$haloe_config["textField"] . ') values ("' .
						$message[$haloe_config["dateField"]] . '", "' .
						$message[$haloe_config["timeField"]] . '", "' .
						$message[$haloe_config["priorityField"]] . '", "' .
						$message[$haloe_config["facilityField"]] . '", "' .
						$message[$haloe_config["hostField"]] . '", "' .
						addslashes($message[$haloe_config["textField"]]) . '")';
		db_execute($sql);
	}
*/

/* DELETE ALL FLAGGED ITEMS FROM THE INCOMING TABLE */
	db_execute("DELETE FROM " . $haloe_config["incomingTable"] . " WHERE status=1");

/* OPTIMIZE THE TABLES ONCE A DAY, JUST TO HELP CLEANUP */
	if (date("G") == 0 && date("i") < 5)
		db_execute("OPTIMIZE TABLE " . $haloe_config["incomingTable"] . ", " . $haloe_config["haloeTable"] . ", " . $haloe_config["removeTable"] . ", " . $haloe_config["alertTable"]);

/* RECONNECT TO THE NORMAL CACTI DATABASE FOR OTHERS TO USE */
	db_connect_real($database_hostname, $database_username, $database_password, $database_default, $database_type);
}

function haloe_config_settings () {
	global $tabs, $settings;
	$tabs["misc"] = "Misc";

	$temp = array(
		"haloe_header" => array(
			"friendly_name" => "Syslog",
			"method" => "spacer",
			),
		"haloe_refresh" => array(
			"friendly_name" => "Refresh Interval",
			"description" => "This is the time in seconds before the page refreshes.  (1 - 300)",
			"method" => "textbox",
			"max_length" => 3,
			),
	);

	if (isset($settings["misc"]))
		$settings["misc"] = array_merge($settings["misc"], $temp);
	else
		$settings["misc"]=$temp;
}

function haloe_top_graph_refresh ($refresh) {
	if (basename($_SERVER["PHP_SELF"]) == "haloe_remove.php")
		return 99999;
	if (basename($_SERVER["PHP_SELF"]) == "haloe_alert.php")
		return 99999;
	if (basename($_SERVER["PHP_SELF"]) != "haloe.php")
		return $refresh;
	$r = read_config_option("haloe_refresh");
	if ($r == '' or $r < 1)
		return $refresh;
	return $r;
}

function haloe_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('haloe.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('haloe.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/haloe/haloe.php"><img src="' . $config['url_path'] . 'plugins/haloe/images/tab_haloe.gif" alt="haloe" align="absmiddle" border="0"></a>';

	}

	haloe_setup_table();

	$r = read_config_option("haloe_refresh");
	$sql = "select * from settings where name='haloe_refresh'";
	$result = db_fetch_assoc($sql);
	if (!isset($result[0]['name']))
		$r = NULL;
	if ($r == '' or $r < 1 or $r > 300) {
		if ($r == '')
			$sql = "replace into settings values ('haloe_refresh','300')";
		else if ($r == NULL)
			$sql = "insert into settings values ('haloe_refresh','300')";
		else
			$sql = "update settings set value = '300' where name = 'haloe_refresh'";
		$result = mysql_query($sql) or die (mysql_error());
		kill_session_var("sess_config_array");
	}
}

function haloe_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[37]='View Syslog';
	$user_auth_realm_filenames['haloe.php'] = 37;

	$user_auth_realms[38]='Configure Syslog Alerts';
	$user_auth_realm_filenames['haloe_alert.php'] = 38;
	$user_auth_realm_filenames['haloe_remove.php'] = 38;


}

function haloe_draw_navigation_text ($nav) {
   $nav["haloe.php:"] = array("title" => "Syslog", "mapping" => "index.php:", "url" => "haloe.php", "level" => "1");
   $nav["haloe_remove.php:"] = array("title" => "Syslog Removals", "mapping" => "index.php:", "url" => "haloe_remove.php", "level" => "1");
   $nav["haloe_alert.php:"] = array("title" => "Syslog Alerts", "mapping" => "index.php:", "url" => "haloe_alert.php", "level" => "1");
   $nav["haloe.php:actions"] = array("title" => "Syslog", "mapping" => "index.php:", "url" => "haloe.php", "level" => "1");
   return $nav;
}

function haloe_setup_table () {
// Return for now until I fix the seperate database issue
return;
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show tables from `" . $database_default . "`";
	
	$result = db_fetch_assoc($sql) or die (mysql_error());

	$tables = array();

	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}

	if (!in_array('haloe_logs', $tables)) {
		$sql = "CREATE TABLE haloe_logs (
			host varchar(32) default NULL,
			facility varchar(10) default NULL,
			priority varchar(10) default NULL,
			level varchar(10) default NULL,
			tag varchar(10) default NULL,
			date date default NULL,
			time time default NULL,
			program varchar(15) default NULL,
			msg text,
			seq int(10) unsigned NOT NULL auto_increment,
			PRIMARY KEY (seq),
			KEY host (host),
			KEY seq (seq),
			KEY program (program),
			KEY time (time),
			KEY date (date),
			KEY priority (priority),
			KEY facility (facility)
			) TYPE=MyISAM;";
		$result = mysql_query($sql) or die (mysql_error());
	}
}

?>
